//
//  Created by baidu.
//  Copyright © 2018年 baidu. All rights reserved.
//
#include "DAPInterstitialAd.h"
#if(CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
#include "platform/android/jni/JniHelper.h"
#endif
#include "InterstitialAdMap.h"
using namespace dap::audience_network;

#if(CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
jobject jAd = NULL;
#endif

DAPInterstitialAd::DAPInterstitialAd(int pid, INTERSTITIAL_TYPE type) {
#if(CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
    placementID = pid;    
    JNIEnv *env = cocos2d::JniHelper::getEnv();
    jclass class_listener = env->FindClass("org/cocos2dx/cpp/DAPCocos2dxInterstitialListener");
    jmethodID mid_listener_init = env->GetMethodID(class_listener, "<init>", "(I)V");
    jobject obj_listener = env->NewObject(class_listener, mid_listener_init, pid);
    jclass class_interstitialAd = env->FindClass("com/duapps/ad/InterstitialAd");
    jmethodID mid_ad_init = env->GetMethodID(class_interstitialAd, "<init>", "(Landroid/content/Context;ILcom/duapps/ad/InterstitialAd$Type;)V");
    jclass cl_type = env->FindClass("com/duapps/ad/InterstitialAd$Type");
    jfieldID id = NULL;
    jobject joAd = NULL;
    if (type == INTERSTITIAL_TYPE::FULL_SCREEN) {
        id = env->GetStaticFieldID(cl_type, "SCREEN", "Lcom/duapps/ad/InterstitialAd$Type;");
    } else {
        id = env->GetStaticFieldID(cl_type, "NORMAL", "Lcom/duapps/ad/InterstitialAd$Type;");
    }
    jobject jo_type = env->GetStaticObjectField(cl_type, id);
    joAd = env->NewObject(class_interstitialAd, mid_ad_init, cocos2d::JniHelper::getActivity(), pid, jo_type);
    jAd = env->NewGlobalRef(joAd);
    jmethodID mid_ad_set_listener = env->GetMethodID(class_interstitialAd, "setInterstitialListener", "(Lcom/duapps/ad/InterstitialListener;)V");
    env->CallVoidMethod(jAd, mid_ad_set_listener, obj_listener);
    env->DeleteLocalRef(obj_listener);
    env->DeleteLocalRef(joAd);
    env->DeleteLocalRef(jo_type);
    env->DeleteLocalRef(cl_type);
    env->DeleteLocalRef(class_interstitialAd);
    env->DeleteLocalRef(class_listener);
#endif
}

DAPInterstitialAd::~DAPInterstitialAd(){
#if(CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
    JNIEnv *env = cocos2d::JniHelper::getEnv();
    env->DeleteGlobalRef(jAd);
#endif
}

void DAPInterstitialAd::fillAd() {
#if(CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
    JNIEnv *env = cocos2d::JniHelper::getEnv();
    jclass class_interstitialAd = env->FindClass("com/duapps/ad/InterstitialAd");
    jmethodID mid_ad_fill = env->GetMethodID(class_interstitialAd, "fill", "()V");
    env->CallVoidMethod(jAd, mid_ad_fill);
    g_interstitial_admap[placementID] = getSharedAd();
    env->DeleteLocalRef(class_interstitialAd);
#endif
}

void DAPInterstitialAd::loadAd() {
#if(CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
    JNIEnv *env = cocos2d::JniHelper::getEnv();
    jclass class_interstitialAd = env->FindClass("com/duapps/ad/InterstitialAd");
    jmethodID mid_ad_load = env->GetMethodID(class_interstitialAd, "load", "()V");
    env->CallVoidMethod(jAd, mid_ad_load);
    g_interstitial_admap[placementID] = getSharedAd();
    env->DeleteLocalRef(class_interstitialAd);
#endif
}

void DAPInterstitialAd::showAd() {
#if(CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
    JNIEnv *env = cocos2d::JniHelper::getEnv();
    jclass class_interstitialAd = env->FindClass("com/duapps/ad/InterstitialAd");
    jmethodID mid_ad_show = env->GetMethodID(class_interstitialAd, "show", "()V");
    env->CallVoidMethod(jAd, mid_ad_show);
    env->DeleteLocalRef(class_interstitialAd);
#endif
}

