//
//  Created by baidu.
//  Copyright © 2018年 baidu. All rights reserved.
//
#ifndef DAP_AUDIENCE_NETWORK_INTERSTITIAL_AD_H_
#define DAP_AUDIENCE_NETWORK_INTERSTITIAL_AD_H_

#include <string>
#include <functional>
#include <memory>
namespace dap {
    namespace audience_network {

        class DAPInterstitialAd;
        enum INTERSTITIAL_TYPE {NOMAL, FULL_SCREEN};
        using InterstitialAdBridgeCallback = std::function<void()>;
        using InterstitialAdBridgeErrorCallback = std::function<void(int)>;

        class DAPInterstitialAd : public std::enable_shared_from_this<DAPInterstitialAd> {
            
        public:
            DAPInterstitialAd(int placementID, INTERSTITIAL_TYPE type);
            ~DAPInterstitialAd();
            void fillAd();
            void loadAd();
            void showAd();
            InterstitialAdBridgeCallback onRecevie;
            InterstitialAdBridgeCallback onPresent;
            InterstitialAdBridgeCallback onClick;
            InterstitialAdBridgeCallback onDismiss;
            InterstitialAdBridgeErrorCallback onDAPAdError;
            std::shared_ptr<DAPInterstitialAd> getSharedAd() {return shared_from_this();}

        private:
            int placementID;
        };
    }
}


#endif
