//
//  Created by baidu.
//  Copyright © 2018年 baidu. All rights reserved.
//
#include "DAPVideoAd.h"
#if(CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
#include "platform/android/jni/JniHelper.h"
#endif
#include "VideoAdMap.h"

using namespace dap::audience_network;

#if(CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
jobject jVideoAd = NULL;
#endif

DAPVideoAd::DAPVideoAd(int pid) {
#if(CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
    placementID = pid;
    JNIEnv *env = cocos2d::JniHelper::getEnv();
    jclass class_listener = env->FindClass("org/cocos2dx/cpp/DAPCocos2dxVideoListener");
    jmethodID mid_listener_init = env->GetMethodID(class_listener, "<init>", "(I)V");
    jobject obj_listener = env->NewObject(class_listener, mid_listener_init, pid);
    jclass class_video_manager = env->FindClass("com/duapps/ad/video/DuVideoAdsManager");
    jmethodID mid_ad_init = env->GetStaticMethodID(class_video_manager, "getVideoAd", "(Landroid/content/Context;I)Lcom/duapps/ad/video/DuVideoAd;");
    jobject joAd = env->CallStaticObjectMethod(class_video_manager, mid_ad_init, cocos2d::JniHelper::getActivity(), pid);
    jVideoAd = env->NewGlobalRef(joAd);
    jclass class_video_ad = env->FindClass("com/duapps/ad/video/DuVideoAd");
    jmethodID mid_ad_set_listener = env->GetMethodID(class_video_ad, "setListener", "(Lcom/duapps/ad/video/DuVideoAdListener;)V");
    env->CallVoidMethod(jVideoAd, mid_ad_set_listener, obj_listener);
    env->DeleteLocalRef(class_video_ad);
    env->DeleteLocalRef(joAd);
    env->DeleteLocalRef(class_video_manager);
    env->DeleteLocalRef(obj_listener);
    env->DeleteLocalRef(class_listener);

#endif
}

DAPVideoAd::~DAPVideoAd(){
#if(CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
    JNIEnv *env = cocos2d::JniHelper::getEnv();
    env->DeleteGlobalRef(jVideoAd);
#endif
}

void DAPVideoAd::playAd() {
#if(CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
    JNIEnv *env = cocos2d::JniHelper::getEnv();
    jclass class_video_ad = env->FindClass("com/duapps/ad/video/DuVideoAd");
    jmethodID mid_ad_play = env->GetMethodID(class_video_ad, "playAd", "(Landroid/content/Context;)V");
    env->CallVoidMethod(jVideoAd, mid_ad_play, cocos2d::JniHelper::getActivity());
    env->DeleteLocalRef(class_video_ad);
#endif
}

void DAPVideoAd::loadAd() {
#if(CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
    JNIEnv *env = cocos2d::JniHelper::getEnv();
    jclass class_video_ad = env->FindClass("com/duapps/ad/video/DuVideoAd");
    jmethodID mid_ad_load = env->GetMethodID(class_video_ad, "load", "()V");
    env->CallVoidMethod(jVideoAd, mid_ad_load);
    g_video_admap[placementID] = getSharedAd();
    env->DeleteLocalRef(class_video_ad);
#endif
}

bool DAPVideoAd::isAdPlayable() {
    bool value;
#if(CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
    JNIEnv *env = cocos2d::JniHelper::getEnv();
    jclass class_video_ad = env->FindClass("com/duapps/ad/video/DuVideoAd");
    jmethodID mid_ad_playable = env->GetMethodID(class_video_ad, "isAdPlayable", "()Z");
    value = env->CallBooleanMethod(jVideoAd, mid_ad_playable);
    env->DeleteLocalRef(class_video_ad);
#endif
    return value;
}




