//
//  Created by baidu.
//  Copyright © 2018年 baidu. All rights reserved.
//
#ifndef DAP_AUDIENCE_NETWORK_VIDEO_AD_H_
#define DAP_AUDIENCE_NETWORK_VIDEO_AD_H_

#include <string>
#include <functional>
#include <memory>

namespace dap {
    namespace audience_network {

        class DAPVideoAd;
        using VideoAdBridgeCallback = std::function<void()>;
        using VideoAdBridgeErrorCallback = std::function<void(int)>;
        using VideoAdBridgeEndCallback = std::function<void(bool, bool)>;

        class DAPVideoAd : public std::enable_shared_from_this<DAPVideoAd> {
            
        public:
            DAPVideoAd(int placementID);
            ~DAPVideoAd();
            void loadAd();
            void playAd();
            bool isAdPlayable();

            VideoAdBridgeCallback onStart;
            VideoAdBridgeCallback onPlayable;
            VideoAdBridgeEndCallback onEnd;
            VideoAdBridgeErrorCallback onError;
            std::shared_ptr<DAPVideoAd> getSharedAd() {return shared_from_this();}
        private:
            int placementID;
        };
    }
}


#endif
