//
//  Created by baidu.
//  Copyright © 2018年 baidu. All rights reserved.
//
#include "org_cocos2dx_cpp_DAPCocos2dxVideoListener.h"
#include "VideoAdMap.h"

#ifdef __cplusplus
extern "C" {
#endif
    
JNIEXPORT void JNICALL Java_org_cocos2dx_cpp_DAPCocos2dxVideoListener_nativeOnAdStart
(JNIEnv *, jclass, jint id) {
    MAP_DAPVIDEO_AD::iterator key = g_video_admap.find(id);
    if (key != g_video_admap.end()) {
        std::shared_ptr<dap::audience_network::DAPVideoAd> ad = key->second;
        ad->onStart();
    }
}

JNIEXPORT void JNICALL Java_org_cocos2dx_cpp_DAPCocos2dxVideoListener_nativeOnAdPlayable
(JNIEnv *, jclass, jint id) {

    MAP_DAPVIDEO_AD::iterator key = g_video_admap.find(id);
    if (key != g_video_admap.end()) {
        std::shared_ptr<dap::audience_network::DAPVideoAd> ad = key->second;
        ad->onPlayable();
    }
}

JNIEXPORT void JNICALL Java_org_cocos2dx_cpp_DAPCocos2dxVideoListener_nativeOnAdEnd
(JNIEnv *, jclass, jint id, jboolean isSuccessfulView, jboolean isCallToActionClicked) {
    MAP_DAPVIDEO_AD::iterator key = g_video_admap.find(id);
    if (key != g_video_admap.end()) {
        std::shared_ptr<dap::audience_network::DAPVideoAd> ad = key->second;
        ad->onEnd(isSuccessfulView, isCallToActionClicked);
    }
}

JNIEXPORT void JNICALL Java_org_cocos2dx_cpp_DAPCocos2dxVideoListener_nativeOnAdError
(JNIEnv *, jclass, jint id, jint errorCode) {

    MAP_DAPVIDEO_AD::iterator key = g_video_admap.find(id);
    if (key != g_video_admap.end()) {
        std::shared_ptr<dap::audience_network::DAPVideoAd> ad = key->second;
        ad->onError(errorCode);
    }
}

#ifdef __cplusplus
}
#endif
