package org.cocos2dx.cpp;

import android.os.Handler;
import android.os.Looper;
import android.util.Log;

import com.duapps.ad.InterstitialListener;

public class DAPCocos2dxInterstitialListener implements InterstitialListener {

    private static final Handler mainThreadHandler = new Handler(Looper.getMainLooper());

    private native static void nativeOnAdReceive(int listenerID);

    private native static void nativeOnAdFail(int listenerID, int errerCode);

    private native static void nativeOnAdClicked(int listenerID);

    private native static void nativeOnAdPresent(int listenerID);

    private native static void nativeOnAdDismissed(int listenerID);

    private final int listenerID;

    public DAPCocos2dxInterstitialListener(int listenerID) {
        this.listenerID = listenerID;

    }

    @Override
    public void onAdClicked() {
        String tag = "JniTest";
        String message = "ad clicked";
        Log.d(tag, message);

        mainThreadHandler.post(new Runnable() {
            public void run() {
                try {
                    DAPCocos2dxInterstitialListener.nativeOnAdClicked(listenerID);
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        });
    }


    @Override
    public void onAdDismissed() {
        String tag = "JniTest";
        String message = "ad dismissed";
        Log.d(tag, message);

        mainThreadHandler.post(new Runnable() {
            public void run() {
                try {
                    DAPCocos2dxInterstitialListener.nativeOnAdDismissed(listenerID);
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        });
    }

    @Override
    public void onAdFail(final int i) {
        String tag = "JniTest";
        String message = "ad fail";
        Log.d(tag, message);

        mainThreadHandler.post(new Runnable() {
            public void run() {
                try {
                    DAPCocos2dxInterstitialListener.nativeOnAdFail(listenerID, i);
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        });
    }

    @Override
    public void onAdPresent() {
        String tag = "JniTest";
        String message = "ad present";
        Log.d(tag, message);

        mainThreadHandler.post(new Runnable() {
            public void run() {
                try {
                    DAPCocos2dxInterstitialListener.nativeOnAdPresent(listenerID);
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        });
    }

    @Override
    public void onAdReceive() {
        String tag = "JniTest";
        String message = "ad receive";
        Log.d(tag, message);

        mainThreadHandler.post(new Runnable() {
            public void run() {
                try {
                    DAPCocos2dxInterstitialListener.nativeOnAdReceive(listenerID);
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        });
    }
}
