package org.cocos2dx.cpp;

import android.os.Handler;
import android.os.Looper;
import android.util.Log;

import com.duapps.ad.AdError;
import com.duapps.ad.video.AdResult;
import com.duapps.ad.video.DuVideoAdListener;

public class DAPCocos2dxVideoListener implements DuVideoAdListener {

    private static final Handler mainThreadHandler = new Handler(Looper.getMainLooper());

    private native static void nativeOnAdStart(int listenerID);

    private native static void nativeOnAdPlayable(int listenerID);

    private native static void nativeOnAdEnd(int listenerID, boolean isSuccessfulView, boolean isCallToActionClicked);

    private native static void nativeOnAdError(int listenerID, int errorCode);

    private final int listenerID;

    public DAPCocos2dxVideoListener(int listenerID) {
        this.listenerID = listenerID;

    }


    @Override
    public void onAdError(final AdError error) {
        String tag = "JniTest";
        String message = "onAdError";
        Log.d(tag, message);

        mainThreadHandler.post(new Runnable() {
            public void run() {
                try {
                    DAPCocos2dxVideoListener.nativeOnAdError(listenerID, error.getErrorCode());
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        });
    }

    @Override
    public void onAdEnd(final AdResult result) {
        String tag = "JniTest";
        String message = "onAdEnd";
        Log.d(tag, message);

        mainThreadHandler.post(new Runnable() {
            public void run() {
                try {
                    DAPCocos2dxVideoListener.nativeOnAdEnd(listenerID, result.isSuccessfulView(), result.isCallToActionClicked());
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        });
    }

    @Override
    public void onAdPlayable() {
        String tag = "JniTest";
        String message = "onAdPlayable";
        Log.d(tag, message);

        mainThreadHandler.post(new Runnable() {
            public void run() {
                try {
                    DAPCocos2dxVideoListener.nativeOnAdPlayable(listenerID);
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        });
    }

    @Override
    public void onAdStart() {
        String tag = "JniTest";
        String message = "onAdStart";
        Log.d(tag, message);

        mainThreadHandler.post(new Runnable() {
            public void run() {
                try {
                    DAPCocos2dxVideoListener.nativeOnAdStart(listenerID);
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        });
    }


}
